﻿'////////////////////////////////////
'/ VBForums Reputation Saver v3.043 /
'/ Edgemeal - July 26, 2015         /
'////////////////////////////////////

#Region "READ ME 1st! / About"
' About:
' ======
' VBForums only shows your last 48 or so reputations, after that,
' they are lost forever. This app saves your reputations!
'
' The code isn't pretty (parts from VB6,etc), but it works! :)
'
' * Special Thanks to ident of vbforums. (Login & download HTML without web browser, and other tips.)
'
' Usage:
' ======
' On first usage enter your name and password for VBforums in Setup.
' Your name and password are saved using My.Settings, password is encrypted.
' To update select "Import New", this will auto login, 
' get & parse your latest reputations and auto logout.
'
' If you have data saved from v1.04 or later just copy the text files,
' ("VBforumReps.txt" & "VBforums_Given_Reps.txt") to this apps folder.
' http://www.vbforums.com/showthread.php?710845-VB10-VBForums-Reputations-Saver-3&p=4412881&viewfull=1#post4412881
'
'Notice: About Your Given Reputation Links
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'There is a bug in the forum software when creating your Given Reputation links.
'When launched the links will only auto scroll to a post that is on the first page of a thread. 
'Some testing of the given rep link bug was discussed here.
'http://www.vbforums.com/showthread.php?753925-Bug-with-the-reputation-links&p=4618061&viewfull=1#post4618061
#End Region

#Region "Version History Notes"
' Version 3 History:
' ==================
' v3.043 - 
' * Fix: Class cTripleDES: Now disposes TripleDESCryptoServiceProvider in a Using/End Using block.
' * Minor: Disabled a line of code (newRep.Capacity=) in Function ParseReps while testing v3.042.
'
' v3.042 - Jan 12, 2015
' * Fix bug: Problems due to auto logout launched before user had chance to answer message boxes.
' * Updated forum version detection to 4.2.2. (no parsing changes were needed.)
'
' v3.041 - (from Update Note: posted Sept 23, 2014).
' Fixed saving reputation URLs with HTML tags, such as "&amp;" (which should be "&").
' If you have a problem launching current saved received reputation URLs then,
' open "VBforumReps.txt" in a text editor, replace "&amp;" with "&" (without quotation marks), and save the file.
'
' v3.04 - 09/12/2014 - * Last and Final Public Release *
' * Restore form to previous WindowState if minimized and a second instance is started (see ApplicationEvents.vb).
' * Close Login form using Escape key.
' * Close Find panel using Escape key (when find textbox has focus).
' * Fix: Login form height was not same as design time. (Set ControlBox to True).
' * Fix: Annoying beep sound when pressing enter key in the Find textbox. (check keys in _Keypress, Set e.Handled = True)
' * Other minor changes.
'
' v3.03 - 07/14/2014
' * Add support for new Spam smilie for comments column.
' * Fix: Reputation place holder image was misnamed. "reputation_none.png" was misnamed in code as "reputation_none.bmp".
'
' v3.02 - 07/01/2014
' * Updates for login. See Class PostData, "v3.02 update:".
' * Replaced status label with a combo to hold a status message history.
' * Check what ver of vBulletin VBF is running, If <> our support notify with option to abort parsing/updating.
' * Encrypt keys are now set in the cTripleDES class, removed the Public declare of the class.
' * Update code to keep search panel in view when moving with mouse, also allow to be moved by the goupbox or lable in panel.
'
' v3.01 - 05/01/2014
' * Changed main parsing sub to a function, now returns a list of the new reputation data.
' * Optimize the way we compare and add new reputations (see repCompare).
' * Add shortcut keys to menu items (people still use keyboards?).
' * Fix: Part of comment text missing when smilie was added between text.(Now checks 4 possible ways for text, but still only supports a single image!).
' * Replace MS.VB classic methods with .Net version, & remove MS.VB.Namespace from references.
' * Replaced "Function htmlConvert" with "HttpUtility.HtmlDecode" to convert html to text.
' * Updated function GetTextBetween to use .Net Split method.
' * Add option to search title, comment, member names.
' * Now uses StringBuilder when saving reps.
'
' v3.00 - Final - 03/28/2014
' * Set encoding to "ISO-8859-1"
' * Replaced buttons with menu.
'
' Testing:
' ========
' Windows 7 (US English), w/IE 10 & 11
' VB10 w/.Net FW 4.0.
'
' Notes:
' ======
' VBForums updated to vBulletin v4.2.2 around Jan 12, 2015.
' VBForums updated to vBulletin v4.2.0 on May 09, 2013.
' VBForums updated to vBulletin v4.1.5 on July 29, 2012.
#End Region

' Imports
Imports System.Runtime.InteropServices
Imports System.Threading

Public Class FrmMain
    ' APIs
#Region "General APIs"
    ' Theming for ListView ' http://www.vbforums.com/showthread.php?645589 , http://www.vbforums.com/showthread.php?647404
    <DllImport("uxtheme", CharSet:=CharSet.Unicode)> _
    Private Shared Function SetWindowTheme(ByVal hWnd As IntPtr, ByVal textSubAppName As String, ByVal textSubIdList As String) As Integer
    End Function
#End Region

    ' Variables
#Region "Variables"
    ' version of vBulletin this app currently supports.
    Private Const vBulletinSupported As String = "4.2.2"

    ' reputation data type
    Private Class ThreadData
        Public Title As String
        Public URL_ID As String
        Public RepDate As String
        Public RepImgIndex As Integer
        Public MemberName As String
        Public Comment As String
        Public CommentImgIndex As Integer
    End Class
    ' user
    Private userName As String = String.Empty ' vbforum user name
    Private userPass As String = String.Empty ' vbforum user password (encypted)
    ' filename to save reps (used for given and received, set in Sub ModeView.)
    Private RepsFile As String
    ' hold web page as text
    Private sourceHTML As String = Nothing
    ' hold rep power and points for comparison after updating.
    Private currentRepPower As Integer
    Private currentRepPoints As Integer
    ' show Received & given rep results after import in one msgbox.
    Private results As String
    ' Holds date and memberName for comparing to html to detect new reps.
    Private repCompare As New List(Of String)

#End Region

    ' Form events
#Region "Form Events"
    ' form load
    Private Sub FrmMain_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ' get user creds.
        Me.userName = My.Settings.User_Name
        Me.userPass = My.Settings.User_Pass
        ' set icon to same as exe
        Me.Icon = My.Resources.program
        ' make ListView Flicker Free!
        Dim aProp As Reflection.PropertyInfo = GetType(ListView).GetProperty("DoubleBuffered", Reflection.BindingFlags.NonPublic Or Reflection.BindingFlags.Instance)
        aProp.SetValue(ListView1, True, Nothing)
        ' set listview to allow image changes on subitems
        SendMessage(ListView1.Handle, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_SUBITEMIMAGES, LVS_EX_SUBITEMIMAGES)
        ' set Theme for ListView ' http://www.vbforums.com/showthread.php?645589 , http://www.vbforums.com/showthread.php?647404
        SetWindowTheme(ListView1.Handle, "Explorer", Nothing)
        ' set mode/get saved reps received.
        ModeView(viewmodes.rcvd)
        ' Add and display default status message on start up.
        UpdateStatus("Idle")
    End Sub

    ' form resize
    Private Sub FrmMain_Resize(sender As Object, e As System.EventArgs) Handles Me.Resize
        ' on resize make sure search panel is in bounds of LV.
        If PnlFind.Visible Then
            ControlInBounds(New Rectangle(Me.ListView1.Left, Me.ListView1.Top, Me.ListView1.Left + Me.ListView1.ClientSize.Width, Me.ListView1.ClientSize.Height), PnlFind)
        End If
    End Sub
#End Region

    ' Menus
#Region "Menus"
    ' Menu - Import new reps.
    Private Sub MnuImportNew_Click(sender As System.Object, e As System.EventArgs) Handles MnuImportNew.Click
        ' check user creds.
        If userName = String.Empty OrElse userPass = String.Empty Then
            MessageBox.Show("Please enter Name and Password in Setup.", "Credentials", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If
        ' get/check if password can be decypted.
        Dim des As New cTripleDES()
        Dim passwordOK As String
        Try
            passwordOK = des.Decrypt(userPass)
        Catch ex As Exception
            MessageBox.Show("Password is corrupted! Please re-enter.", "Credentials", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End Try

        ' lock
        Me.Cursor = Cursors.AppStarting
        MenuMain.Enabled = False
        ' reset
        sourceHTML = Nothing
        results = "" ' clear imported rep info for msgbox
        ' clear status list box
        CboStatus.Items.Clear()
        ' show about to open forums settings
        UpdateStatus("Open VBForums member settings")
        ' start login...
        If Me.m_postData Is Nothing Then
            Me.m_postData = New PostData()
        End If
        Dim hashClass As New MD5Class()
        Dim hash As String = hashClass.GetMd5Hash(passwordOK)
        InitiateThread(DirectCast(Sub() Me.m_postData.TryLogin(Me.userName, hash.ToLower, True), ThreadStart))
    End Sub

    ' Menu - Show search panel
    Private Sub MnuFind_Click(sender As System.Object, e As System.EventArgs) Handles MnuFind.Click
        PnlFind.Visible = True
        TxtFind.Focus()
    End Sub

    ' Menu - Setup (edit User Name & Password).
    Private Sub MnuSetup_Click(sender As System.Object, e As System.EventArgs) Handles MnuSetup.Click
        Using f As New FrmSetUp
            ' get user creds.
            f.UserName = Me.userName
            f.UserPass = Me.userPass ' note: password is encypted!
            f.StartPosition = FormStartPosition.Manual
            f.Location = Me.PointToScreen(New Point(Me.ListView1.Location.X + 6, Me.ListView1.Location.Y + 6))
            If f.ShowDialog = Windows.Forms.DialogResult.OK Then
                ' save user settings to config
                My.Settings.User_Name = f.UserName
                My.Settings.User_Pass = f.UserPass
                My.Settings.Save()
                ' save settings locally
                Me.userName = f.UserName
                Me.userPass = f.UserPass
            End If
        End Using
    End Sub

    ' Menu - View Received
    Private Sub MnuViewReceived_Click(sender As System.Object, e As System.EventArgs) Handles MnuViewReceived.Click
        ModeView(viewmodes.rcvd)
    End Sub

    ' Menu - View Given
    Private Sub MnuViewGiven_Click(sender As System.Object, e As System.EventArgs) Handles MnuViewGiven.Click
        ModeView(viewmodes.given)
    End Sub

    ' Menu - Exit
    Private Sub MnuExit_Click(sender As System.Object, e As System.EventArgs) Handles MnuExit.Click
        Me.Close()
    End Sub

#End Region

    ' HTTP Stuff
#Region "Http Web Request, Returns html source"
    Private WithEvents m_postData As PostData

    ' Raised Events, RETURNED DATA AFTER LOGIN
    Private Sub ReturnedPageSource(ByVal sender As Object, ByVal e As EventArgs) Handles m_postData.ReturnedPageSource
        If Me.InvokeRequired Then
            Me.Invoke(New Action(Of Object, EventArgs)(AddressOf ReturnedPageSource), sender, e)
        Else
            ' save html source to variable
            sourceHTML = DirectCast(e, ReturnedPageSourceEventArghs).ReturnedPageSourceValue
            ' check if forums are down for maintenance, etc....(vBulletin 4.1.5 & 4.2.0).
            If sourceHTML.Contains("The forums are currently down") Then
                ' show status 
                UpdateStatus("VBForums are currently down.")
                Me.Cursor = Cursors.Default
                MessageBox.Show("VBForums are currently down.", "Forum Down", MessageBoxButtons.OK, MessageBoxIcon.Information)
                MenuMain.Enabled = True
                Return
            End If
            ' did we get the member setting page?, and does it have Reps?
            If sourceHTML.Contains("<!-- ############## REPUTATION") Then
                ' show getting user settings was a success.
                UpdateStatus("Member settings downloaded OK!")
                ' check if forum is using a different version of vBulletin then what we currently support.
                ' i.e., <meta name="generator" content="vBulletin 4.2.0" />
                Dim vBulletinVersion = GetTextBetween(sourceHTML, "<meta name=""generator"" content=""vBulletin ", """")
                If vBulletinVersion <> "" AndAlso vBulletinVersion <> vBulletinSupported Then
                    ' show vB version changed
                    UpdateStatus("Support: vBulletin version mismatch.")
                    Me.Cursor = Cursors.Default
                    If MessageBox.Show("Notice! This program may need to be updated!" _
                                   & Environment.NewLine _
                                   & "VBForums has changed to vBulletin version " & vBulletinVersion _
                                   & Environment.NewLine & Environment.NewLine _
                                   & "Do you feel lucky punk? Continue anyway?" _
                                   , "Version Check" _
                                   , MessageBoxButtons.YesNo _
                                   , MessageBoxIcon.Question _
                                   , MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.No Then
                        ' do logout
                        UpdateStatus("Logout VBForums")
                        If Me.m_postData IsNot Nothing Then
                            InitiateThread(DirectCast(Sub() Me.m_postData.TryLogout(), ThreadStart))
                        End If
                        MenuMain.Enabled = True
                        Return
                    Else ' set cursor to busy/wait, and start parsing source html
                        Me.Cursor = Cursors.AppStarting
                    End If
                End If
                ' parse Received reps, adds new reps to LV & saves to file.
                AddRcvdReps()
                ' parse given reps, adds new reps to LV & saves to file.
                AddGivenReps()
                ' parsing done
                UpdateStatus("Updates completed.") '- Import new reps finished
                ' clear html page from memory
                sourceHTML = Nothing
                ' do logout
                UpdateStatus("Logout VBForums")
                If Me.m_postData IsNot Nothing Then
                    InitiateThread(DirectCast(Sub() Me.m_postData.TryLogout(), ThreadStart))
                End If
                ' reset cursor
                Me.Cursor = Cursors.Default
                ' show results from both received and given reps.
                MessageBox.Show(results, "New Rep Info", MessageBoxButtons.OK, MessageBoxIcon.Information)
                ' allow user to select
                MenuMain.Enabled = True
            Else ' other web pages: After a logout we should find "All cookies cleared!"
                If sourceHTML.Contains(""">All cookies cleared!") Then
                    UpdateStatus("All cookies cleared!")
                End If
                ' clear html page from memory
                sourceHTML = Nothing
            End If
        End If
    End Sub

    ' Raised Events, Error! :(
    Private Sub LastError(ByVal sender As Object, ByVal e As EventArgs) Handles m_postData.LastError
        If Me.InvokeRequired Then
            Me.Invoke(New Action(Of Object, EventArgs)(AddressOf Me.LastError), sender, e)
        Else
            'show error
            Dim lastError As Exception = DirectCast(e, LastErrorEventArghs).LastErrorValue
            ' show error
            UpdateStatus("Error: " & lastError.Message)
            MessageBox.Show(String.Format("Logged in = {0} Last error = {1}", Me.m_postData.IsLoggedIn, lastError.Message) _
                            , Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Error)
            ' reset cursor
            Me.Cursor = Cursors.Default
            ' reset app
            MenuMain.Enabled = True ' allow user to select
            sourceHTML = Nothing ' clear html page from memory
            ' if logged in then logout!
            If Me.m_postData IsNot Nothing Then
                If Me.m_postData.IsLoggedIn Then
                    ' show logged out attempted.
                    UpdateStatus("Logout VBForums after error")
                    Me.m_postData.TryLogout()
                End If
            End If
        End If
    End Sub

    ' thread
    Private Sub InitiateThread(ByVal ThreadStart As ThreadStart)
        Dim t As New Thread(ThreadStart)
        t.IsBackground = True
        t.Start()
    End Sub
#End Region

    ' Set Rep mode/View mode
#Region "View Mode"
    Private Enum viewmodes
        given = 0
        rcvd = 1
    End Enum

    Private Sub ModeView(ByVal viewmode As viewmodes)
        If viewmode = viewmodes.rcvd Then
            Me.Text = "VBForums Reputation Saver 3 - Received"
            ' set menu to recv mode 
            MnuViewReceived.Checked = True
            MnuViewGiven.Checked = False
            ' set mode to received...
            currentRepPoints = 0
            ListView1.BackColor = Color.AliceBlue ' set backcolor of LV for rcvd mode
            ListView1.Columns(2).Text = "Rep from"
            ListView1.Columns(3).Text = "Comment"
            RepsFile = IO.Path.Combine(Application.StartupPath, "VBforumReps.txt")
        Else ' set mode to given
            Me.Text = "VBForums Reputation Saver 3 - Given"
            MnuViewGiven.Checked = True
            MnuViewReceived.Checked = False
            currentRepPower = 0
            ListView1.BackColor = Color.AntiqueWhite  ' set backcolor of LV for given mode
            ListView1.Columns(2).Text = "Rep given to"
            ListView1.Columns(3).Text = "My comment"
            RepsFile = IO.Path.Combine(Application.StartupPath, "VBforums_Given_Reps.txt")
        End If
        ' load reps power/points
        LoadReps()
    End Sub
#End Region

    ' load and save reps
#Region "Load and Save Reps"
    ' Load Reputations from file
    Private Sub LoadReps()
        ListView1.BeginUpdate()
        ListView1.Items.Clear()
        repCompare.Clear()
        ' check if we have a file
        If IO.File.Exists(RepsFile) Then
            Try
                Dim lines() As String = IO.File.ReadAllLines(RepsFile)
                ' show saved rep power/points
                ' v3.02: "Reputation Power" has been replaced with just "Power" so remove "Reputation" from old saved data!
                lblPoints.Text = lines(0).Replace("Reputation ", "")
                ' save current rep power/points for comparison after update.
                If lines(0).Contains("Point(s)") Then
                    'get rep points from saved text file as integer
                    Dim findPoints = lines(0).IndexOf(" ")
                    If findPoints > -1 Then
                        Integer.TryParse(lines(0).Substring(0, findPoints), currentRepPoints)
                    Else
                        currentRepPoints = 0
                    End If
                Else 'get current Rep Power from saved text file as integer
                    Dim findPower = lines(0).IndexOf(":")
                    If findPower > -1 Then
                        Integer.TryParse(lines(0).Substring(findPower + 1), currentRepPower)
                    Else
                        currentRepPower = 0
                    End If
                End If
                ' get rest of data, add to LV.
                For i As Integer = 1 To lines.Length - 1
                    Dim entry() As String = lines(i).Split({Convert.ToChar(Keys.Tab)}, StringSplitOptions.None)
                    Dim lvi As ListViewItem = ListView1.Items.Add(entry(0), CInt(entry(5)))
                    lvi.SubItems.AddRange({entry(1), entry(2), entry(3), entry(4)})
                    ' add comment smilies image index to LV item Tag property.
                    lvi.Tag = entry(6)
                    ' set LV subitem image: comment column(3) smilies image.
                    ListView_SetSubItemImageIndex(ListView1.Handle, ListView1.Items.Count - 1, ListView1.Columns(3).Index, CInt(entry(6)))
                    ' save RepDate & MemberName to list, used to compare when parsing html source for new reps.
                    repCompare.Add(entry(1) & entry(2))
                Next ' - next line
            Catch ex As Exception
                MessageBox.Show(ex.Message, "File Load Error", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
            End Try
            ' sort date column desending
            sortDateColumnDesend()
            ' resize "date" and "rep from/given" columns
            ListView1.AutoResizeColumn(1, ColumnHeaderAutoResizeStyle.HeaderSize)
            ListView1.AutoResizeColumn(2, ColumnHeaderAutoResizeStyle.HeaderSize)
            ' show number of reps.
            lblNumReps.Text = "Reps:" & ListView1.Items.Count.ToString
        Else ' - no rep file
            lblPoints.Text = "No data saved!"
            lblNumReps.Text = "Reps:0"
        End If
        ' end LV update
        ListView1.EndUpdate()
    End Sub

    ' Save Reputations to file
    Private Sub SaveReps()
        Dim sbRepData As New System.Text.StringBuilder
        ' save Rep Power or Points to first line in file from label lblPoints.
        sbRepData.AppendLine(lblPoints.Text)
        ' build LV data for saving
        For i As Integer = 0 To ListView1.Items.Count - 1
            With ListView1.Items(i) ' SubItems
                For j As Integer = 0 To 4
                    sbRepData.Append(.SubItems.Item(j).Text & Convert.ToChar(Keys.Tab))
                Next
                ' add imagelist indexes for Reputation image and Comment-smilies image.
                sbRepData.AppendLine(.ImageIndex.ToString & Convert.ToChar(Keys.Tab) & .Tag.ToString)
            End With
        Next
        ' save all data to file
        Try
            IO.File.WriteAllText(RepsFile, sbRepData.ToString)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "File Save Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End Try
    End Sub
#End Region

    ' LV API, Sorting, Subs
#Region "LV Sorting and extras"

    ' LV API - draw image on subitems
#Region "LV API - Draw SubItem Image"
    ' Credit: C. Sibon, http://www.Planet-Source-Code.com/vb/scripts/ShowCode.asp?txtCodeId=8823&lngWId=10
    ' partially from source: http://www.groupsrv.com/dotnet/about180142.html
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
    Friend Structure LVITEM
        Friend mask As Integer
        Friend iItem As Integer
        Friend subItem As Integer
        Friend state As Integer
        Friend stateMask As Integer
        <MarshalAs(UnmanagedType.LPTStr)>
        Friend lpszText As String
        Friend cchTextMax As Integer
        Friend iImage As Integer
        Friend lParam As IntPtr
        Friend iIndent As Integer
    End Structure

    Friend Const LVM_FIRST As Integer = &H1000
    Friend Const LVM_GETITEMA As Integer = LVM_FIRST + 5
    Friend Const LVM_GETITEMW As Integer = LVM_FIRST + 75
    Friend Const LVM_SETITEMA As Integer = LVM_FIRST + 6
    Friend Const LVM_SETITEMW As Integer = LVM_FIRST + 76
    Friend Shared ReadOnly LVM_GETITEM As Integer = CInt(If(Marshal.SystemDefaultCharSize = 1, LVM_GETITEMA, LVM_GETITEMW))
    Friend Shared ReadOnly LVM_SETITEM As Integer = CInt(If(Marshal.SystemDefaultCharSize = 1, LVM_SETITEMA, LVM_SETITEMW))
    Friend Const LVM_SETEXTENDEDLISTVIEWSTYLE As Integer = LVM_FIRST + 54
    Friend Const LVIF_IMAGE As Integer = &H2
    Friend Const LVS_EX_SUBITEMIMAGES As Integer = &H2

    Friend Shared Function ListView_SetItem(ByVal hwnd As IntPtr, ByRef lvi As LVITEM) As Boolean
        Return CBool(SendMessage(hwnd, LVM_SETITEM, IntPtr.Zero, lvi))
    End Function

    Friend Overloads Declare Auto Function SendMessage Lib "User32.dll" (ByVal hwnd As IntPtr, ByVal msg As Integer, ByVal wParam As IntPtr, ByRef lParam As LVITEM) As Integer
    Friend Overloads Declare Auto Function SendMessage Lib "User32.dll" (ByVal hwnd As IntPtr, ByVal msg As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer

    Friend Shared Sub ListView_SetSubItemImageIndex(ByVal hwnd As IntPtr, ByVal index As Integer, ByVal subItemIndex As Integer, ByVal imageIndex As Integer)
        Dim lvi As LVITEM
        lvi = Nothing
        lvi.iItem = index
        lvi.subItem = subItemIndex
        lvi.iImage = imageIndex
        lvi.mask = LVIF_IMAGE
        ListView_SetItem(hwnd, lvi)
    End Sub

    ' ***********************
    ' [ Get Item - Not Used ]
    ' ***********************
    'Friend Shared Function ListView_GetItem(ByVal hwnd As IntPtr, ByRef lvi As LVITEM) As Boolean
    '    Return CBool(SendMessage(hwnd, LVM_GETITEM, IntPtr.Zero, lvi))
    'End Function
    '
    'Friend Shared Function ListView_GetSubItemImageIndex(ByVal hwnd As IntPtr, ByVal index As Integer, ByVal subItemIndex As Integer) As Integer
    '    Dim lvi As LVITEM
    '    lvi = Nothing
    '    lvi.iItem = index
    '    lvi.subItem = subItemIndex
    '    lvi.mask = LVIF_IMAGE
    '    If ListView_GetItem(hwnd, lvi) Then
    '        Return lvi.iImage
    '    Else
    '        Return -1
    '    End If
    'End Function
#End Region

    ' sorting variables
    Private SortingDirection As Integer = SortOrder.Descending

    ' Sort date column desending
    Private Sub sortDateColumnDesend()
        SortingDirection = SortOrder.Descending
        ListView1.ListViewItemSorter = New SortByDate(SortingDirection)
        ListView1.Sort()
        SetColImage(1) ' show down arrow on date column
        ListView1.ListViewItemSorter = Nothing
        SortingDirection = SortOrder.Ascending ' since last sort was desend set sort to Asend for next sorting op.
    End Sub

    ' Comparer - Sort LV columns (other then date column)
    Private Class comparer1
        Implements IComparer
        Private sorting, column As Integer
        Public Sub New(ByVal SortDirection As Integer, ByVal ColumnToSort As Integer)
            sorting = SortDirection
            column = ColumnToSort
        End Sub
        Private Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
            If sorting = SortOrder.Ascending Then
                Return DirectCast(x, ListViewItem).SubItems(column).Text.CompareTo(DirectCast(y, ListViewItem).SubItems(column).Text)
            Else
                Return DirectCast(y, ListViewItem).SubItems(column).Text.CompareTo(DirectCast(x, ListViewItem).SubItems(column).Text)
            End If
        End Function
    End Class

    ' Comparer - Sort by date , Column(1)
    Private Class SortByDate
        Implements IComparer
        ' In order to convert strings to dates we need to remove chars,
        ' "st", "nd", "rd", "th", from the date strings. i.e. "Jan 1st, 2010 12:36 PM" , "Feb 8th, 2014 03:43 AM"
        Private removes() As String = ({"rd,", "th,", "nd,", "st,"})
        Private sX, sY As String
        Private sorting As Integer
        Public Sub New(ByVal SortDirection As Integer)
            sorting = SortDirection
        End Sub
        Private Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
            sX = DirectCast(x, ListViewItem).SubItems(1).Text
            sY = DirectCast(y, ListViewItem).SubItems(1).Text
            ' remove unwanted chars from string dates
            For i As Integer = 0 To removes.Length - 1
                sX = sX.Replace(removes(i), "")
                sY = sY.Replace(removes(i), "")
            Next
            ' sort as dates by selected order
            If sorting = SortOrder.Ascending Then
                Return (Convert.ToDateTime(sX)).CompareTo(Convert.ToDateTime(sY))
            Else
                Return (Convert.ToDateTime(sY)).CompareTo(Convert.ToDateTime(sX))
            End If
        End Function
    End Class

    ' LV ColumnClick - sort column 
    Private Sub ListView1_ColumnClick(sender As Object, e As System.Windows.Forms.ColumnClickEventArgs) Handles ListView1.ColumnClick
        SetColImage(e.Column)
        If e.Column = 1 Then ' note sort by dates (requires special trimming!)
            ListView1.ListViewItemSorter = New SortByDate(SortingDirection)
        Else
            ListView1.ListViewItemSorter = New comparer1(SortingDirection, e.Column)
        End If
        ' do the sort
        ListView1.Sort()
        ListView1.ListViewItemSorter = Nothing

        'v3.02 updated:(simplify) - flip the sort direction for next sort operation.
        SortingDirection = If(SortingDirection = SortOrder.Ascending, SortOrder.Descending, SortOrder.Ascending)

        ' if item selected then keep it in view
        If ListView1.SelectedIndices.Count > 0 Then
            ListView1.EnsureVisible(ListView1.SelectedIndices(0))
        End If
    End Sub

    ' Sort Selected Items
    Private Class LV_SelectedSorter
        Implements IComparer
        Public Sub New()
        End Sub
        Private Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
            If DirectCast(x, ListViewItem).Selected Then
                Return -1
            Else
                Return 1
            End If
        End Function
    End Class ' <- Sort Selected Items

    ' Set column header arrow image
    Private Sub SetColImage(column As Integer)
        For i As Integer = 0 To ListView1.Columns.Count - 1
            If i <> column Then
                ' set column header to blank image
                ListView1.Columns(i).ImageIndex = ImageList1.Images.IndexOfKey("blank_arrow.bmp")
            Else ' Set image for selected column header
                If SortingDirection = SortOrder.Ascending Then
                    ListView1.Columns(column).ImageIndex = ImageList1.Images.IndexOfKey("up_arrow.bmp")
                Else
                    ListView1.Columns(column).ImageIndex = ImageList1.Images.IndexOfKey("down_arrow.bmp")
                End If
            End If
        Next
    End Sub

    ' Launch URL for selected rep on double click
    Private Sub ListView1_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListView1.MouseDoubleClick
        ' only allow left mouse button clicks
        If e.Button = Windows.Forms.MouseButtons.Left Then
            ' get item at mouse location
            Dim lvi As ListViewItem = ListView1.HitTest(e.Location).Item
            If lvi IsNot Nothing Then
                ' get url_id from subitem 4
                Dim url_Id As String = lvi.SubItems(4).Text.Trim
                ' if not blank launch URL with default web browser
                If url_Id.Length > 0 Then
                    'If the saved url is from "Given Reps" then it must use the newer base URL!
                    If MnuViewGiven.Checked Then
                        Process.Start("http://www.vbforums.com/showthread.php?" & url_Id)
                    Else
                        'if url from new reputation saver using vBulletin v4.x.x then use the newer base url.
                        If url_Id.Contains("p=") Then
                            Process.Start("http://www.vbforums.com/showthread.php?" & url_Id)
                        Else ' support our old saved urls from vBulletin v3.8.1,
                            Process.Start("http://www.vbforums.com/showthread.php?p=" & url_Id)
                        End If
                    End If
                Else
                    MessageBox.Show("No URL for this entry.", "No URL", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
            End If
        End If
    End Sub

#End Region

    ' Search LV
#Region "Search LV"
    ' button - close find (hide panel)
    Private Sub BtnCloseFind_Click(sender As System.Object, e As System.EventArgs) Handles BtnCloseFind.Click
        PnlFind.Visible = False
    End Sub

    ' textbox - find - keypress
    Private Sub TxtFind_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles TxtFind.KeyPress
        ' detect enter /return keypress
        If e.KeyChar = Convert.ToChar(Keys.Return) Then
            ' prevent annoying beep sound when enter key pressed.
            e.Handled = True
            ' if have text then do the search
            If TxtFind.Text.Trim.Length > 0 Then
                BtnFind.PerformClick()
            End If
        ElseIf e.KeyChar = Convert.ToChar(Keys.Escape) Then ' Close Find on Escape key.
            e.Handled = True  ' prevent annoying beep sound when enter key pressed.
            PnlFind.Visible = False ' hide the find panel
            ListView1.Select() ' select LV
        End If
    End Sub

    ' textbox - find - changed
    Private Sub TxtFind_TextChanged(sender As System.Object, e As System.EventArgs) Handles TxtFind.TextChanged
        BtnFind.Enabled = Not TxtFind.Text.Trim.Length = 0
    End Sub

    ' button - find - click
    Private Sub BtnFind_Click(sender As System.Object, e As System.EventArgs) Handles BtnFind.Click
        If TxtFind.Text.Trim.Length = 0 Then
            MessageBox.Show("Please enter the text to find.", "Nothing To Search", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else ' do the search
            ' unselect all items
            ListView1.SelectedItems.Clear()
            ListView1.BeginUpdate()
            '...
            Dim searchText As String = TxtFind.Text.ToLower
            Dim lvText As String = ""
            For Each lvi As ListViewItem In ListView1.Items
                Select Case True
                    Case RadFindThreadTitle.Checked
                        lvText = lvi.Text.ToLower
                    Case RadFindMember.Checked
                        lvText = lvi.SubItems(2).Text.ToLower
                    Case RadFindComment.Checked
                        lvText = lvi.SubItems(3).Text.ToLower
                End Select
                ' if search found then select the LV item.
                If lvText.Contains(searchText) Then
                    lvi.Selected = True
                End If
            Next
            ' check if items were found.
            If ListView1.SelectedIndices.Count = 0 Then
                ListView1.EndUpdate()
                MessageBox.Show("Search text not found.", "Not Found", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                ' Items found,...
                'first sort all items by Dates descending, so newest item will be at top of list!
                sortDateColumnDesend()
                ' sort by selected items, move selected to top of LV.
                ListView1.ListViewItemSorter = New LV_SelectedSorter()
                ListView1.Sort()
                ListView1.ListViewItemSorter = Nothing
                ' to make LV scroll to the top
                ListView1.EnsureVisible(0)
                ' fini, update lv
                ListView1.EndUpdate()
                ' hide the find panel
                PnlFind.Visible = False
                ' select LV
                ListView1.Select()
            End If
        End If
    End Sub

    ' move search panel with mouse
    Private Sub PnlFind_MouseDown(sender As Object, e As System.Windows.Forms.MouseEventArgs) _
                Handles PnlFind.MouseDown, GroupBox1.MouseDown, Label1.MouseDown

        If e.Button = Windows.Forms.MouseButtons.Left Then
            ' get the control the mouse is down on (the panel has a lable and a group box too)
            Dim c = DirectCast(sender, Control)
            ' release mouse capture 
            c.Capture = False
            ' set cursor for panel move
            c.Cursor = Cursors.SizeAll
            ' move panel with mouse 'Const HT_CAPTION = &H2   'Const WM_NCLBUTTONDOWN = &HA1
            Me.DefWndProc(Message.Create(Me.PnlFind.Handle, &HA1, New IntPtr(&H2), IntPtr.Zero))
            '     ! ! ! DON'T FORGET ! ! !
            '<-- mouse up is detected here! -->
            ' on mouse up make sure panel is in view inside the LV area.
            ControlInBounds(New Rectangle(Me.ListView1.Left, Me.ListView1.Top, Me.ListView1.Left + Me.ListView1.ClientSize.Width, Me.ListView1.ClientSize.Height), Me.PnlFind)
            ' reset cursor
            c.Cursor = Cursors.Default
        End If
    End Sub

    ' helper sub - keep a control in-bounds of area
    Private Sub ControlInBounds(parentRect As Rectangle, child As Control)
        ' note: using an offset of 8 pixels so control isn't positioned right on the edges of parent rect.
        If child.Right > parentRect.Right - 8 Then
            child.Left = parentRect.Right - (child.Width + 8)
        ElseIf child.Left < parentRect.Left + 8 Then
            child.Left = parentRect.Left + 8
        End If
        If child.Top < parentRect.Top + 8 Then
            child.Top = parentRect.Top + 8
        ElseIf child.Bottom > parentRect.Bottom - 8 Then
            child.Top = parentRect.Bottom - (child.Height + 8)
        End If
    End Sub
#End Region

    ' Parse source HTML, Add Reputations
#Region "Parsing and Adding Reputations"
    'Parse source HTML
    Private Function ParseReps(RepHtmlStart As String, RepHtmlEnd As String) As List(Of ThreadData)
        '/////////////////////////////////////////////////////
        '//  Parse html for received or given reputation    //
        '//  vBulletin v4.2.0 - VBForums: May, 09, 2013     //
        '/////////////////////////////////////////////////////
        Dim sTmp As String
        ' html area of "reps type"...
        Dim html = GetTextBetween(sourceHTML, RepHtmlStart, RepHtmlEnd)
        ' split reputation threads into array
        Dim repThread() As String = html.Split({"<li class=""floatcontainer blockrow"}, StringSplitOptions.RemoveEmptyEntries)
        ' list to hold new reps
        Dim newRep As New List(Of ThreadData)
        newRep.Capacity = repThread.Length - 1
        'Get thread data....
        For i = 1 To repThread.Length - 1 ' start at index 1.
            Try
                ' use temp variable to hold for thread rep data, if no errors then add it to the newrep list.
                Dim tempRep As New ThreadData
                ' get DATE TIME '<div class="datetime">Jun 1st, 2013 <span class="time">03:53 PM</span></div>
                sTmp = GetTextBetween(repThread(i), "<div class=""datetime"">", "</span>")
                tempRep.RepDate = sTmp.Replace("<span class=""time"">", "").Trim

                ' get user name of rep,  '<a href="member.php?1857763-name here">name here</a>
                sTmp = GetTextBetween(repThread(i), "<a href=""member.php?", "/a>")
                tempRep.MemberName = GetTextBetween(sTmp, ">", "<").Trim

                ' check if this RepDate & MemberName are already in our rep list, if not then continue parsing.
                If Not repCompare.Contains(tempRep.RepDate & tempRep.MemberName) Then
                    ' get URL & thread title, '<a class="smallfont" href="showthread.php?723533-cant-save-with-folderbrowsedialog&amp;p=4426851#post4426851">cant save with folderbrowsedialog</a>
                    sTmp = GetTextBetween(repThread(i), "href=""showthread.php", "/a>")
                    ' update v3.041.
                    tempRep.URL_ID = System.Web.HttpUtility.HtmlDecode(GetTextBetween(sTmp, "?", """>").Trim)
                    sTmp = GetTextBetween(sTmp, """>", "<").Trim
                    tempRep.Title = System.Web.HttpUtility.HtmlDecode(sTmp)

                    ' get comment text & image, 4 possiblities,...
                    '<p class="comment">BLA BLA <img src="images... /></p>
                    '<p class="comment">BLA1 BLA1 <img src="images... /> BLA2 BLA2</p>
                    '<p class="comment"><img src="images... /> BLA BLA BLA</p>
                    '<p class="comment"><i>No Comment Made</i></p>

                    ' get comment text & image (smilies)
                    Dim commentLine = GetTextBetween(repThread(i), "<p class=""comment"">", "</p>").Trim
                    Dim commentImage = GetTextBetween(commentLine, "<img src=""", " />").Trim
                    Dim commentText = commentLine.Replace("<img src=""" & commentImage & " />", "").Trim
                    ' if no comment or smilies then forum will add the text "No Comment" with italic tags, so remove them!
                    commentText = commentText.Replace("<i>", "")
                    commentText = commentText.Replace("</i>", "")
                    tempRep.Comment = System.Web.HttpUtility.HtmlDecode(commentText)
                    ' get smilie image in comment, images/smilies/thumb.gif" border="0" 
                    If commentImage <> "" Then
                        ' get image name
                        Dim imgName = GetTextBetween(commentImage, "images/smilies/", """")
                        ' find matching file name in image list, save image index. 
                        tempRep.CommentImgIndex = ImageList1.Images.IndexOfKey(imgName)
                    Else ' did not detect any smilies in members comment.
                        tempRep.CommentImgIndex = -1
                    End If

                    'Get Reputation image type, summaryinfo pos" id="reputationbit_8357_1834">
                    sTmp = GetTextBetween(repThread(i), "summaryinfo ", """").Trim
                    If sTmp = "pos" Then
                        tempRep.RepImgIndex = ImageList1.Images.IndexOfKey("reputation_pos.png")
                    ElseIf sTmp = "balance" Then
                        tempRep.RepImgIndex = ImageList1.Images.IndexOfKey("reputation_balance.png")
                    ElseIf sTmp.Contains("neg") Then
                        tempRep.RepImgIndex = ImageList1.Images.IndexOfKey("reputation_neg.png")
                    Else ' couldnt parse rep? set to blank rep image.
                        '(NOTE: This was never needed, but is now a placeholder!
                        '       Do Not remove the image from imagelist,
                        '       or indexes to images saved in rep files will point,
                        '       to the wrong or invalid image index!!!
                        tempRep.RepImgIndex = ImageList1.Images.IndexOfKey("reputation_none.png") ' FIX: v3.03 , was ".bmp" 
                    End If
                    'add new reputation
                    newRep.Add(tempRep)
                End If
            Catch ex As Exception
                UpdateStatus("Parse Error: " & ex.Message)
                'MessageBox.Show(ex.Message)
                'Debug.WriteLine(ex.Message)
            End Try
        Next
        repCompare.Clear()
        Return newRep
    End Function

    ' Add & Save new Reps Given
    Private Sub AddGivenReps()
        UpdateStatus("Updating Reputation Given")
        ' set to reps GIVEN mode
        ModeView(viewmodes.given)
        ' list to hold new given reputation data.
        Dim repGivenThreads As New List(Of ThreadData)
        ' Parse given reps from html source
        repGivenThreads = ParseReps("<!-- ############## REPUTATION GIVEN", "<!-- ############## END REPUTATION GIVEN")
        ' add new given reputations
        For Each newGivenRep In repGivenThreads
            With newGivenRep
                Dim lvi As ListViewItem = ListView1.Items.Add(.Title, .RepImgIndex)
                lvi.SubItems.AddRange({.RepDate, .MemberName, .Comment, .URL_ID})
                lvi.Tag = .CommentImgIndex ' store comment image index in Tag prop.
                ' set image for comment column(3) @ current row 
                If .CommentImgIndex > -1 Then
                    ListView_SetSubItemImageIndex(ListView1.Handle, ListView1.Items.Count - 1, ListView1.Columns(3).Index, .CommentImgIndex)
                End If
            End With
        Next
        ' - all done checking for new given reps! -
        '
        ' get new rep power
        Dim strRepPower As String = GetTextBetween(sourceHTML, "(Reputation Power:", ")").Trim
        ' did we get more power? ' v3.01 - updated
        Dim powerAdded As Integer
        Integer.TryParse(strRepPower, powerAdded)
        Dim addedPower As Integer = powerAdded - currentRepPower

        ' if new reps or added power then save data!
        If repGivenThreads.Count > 0 OrElse addedPower > 0 Then
            ' sort date column desending
            sortDateColumnDesend()
            ' show new rep power
            lblPoints.Text = "Power: " & strRepPower
            lblPoints.Refresh()
            ' save my rep power and given reps to file.
            SaveReps()
        End If
        ' show result
        lblNumReps.Text = "Reps:" & ListView1.Items.Count.ToString
        lblNumReps.Refresh()
        'Add rep given info to string
        results &= "New Reps Given: " & repGivenThreads.Count.ToString & Environment.NewLine & "Rep Power: +" & addedPower.ToString & Environment.NewLine
    End Sub

    ' Add & Save new Reps Received
    Private Sub AddRcvdReps()
        ' 
        UpdateStatus("Updating Reputation Received")
        ' set to reps received mode
        ModeView(viewmodes.rcvd)
        ' list to hold data for new Received reputation data.
        Dim repRcvdThreads As New List(Of ThreadData)
        ' Parse received reps
        repRcvdThreads = ParseReps("<!-- ############## REPUTATION RECEIVED", "<!-- ############## END REPUTATION RECEIVED")
        For Each newRepRcvd In repRcvdThreads
            With newRepRcvd
                Dim lvi As ListViewItem = ListView1.Items.Add(.Title, .RepImgIndex)
                lvi.SubItems.AddRange({.RepDate, .MemberName, .Comment, .URL_ID})
                lvi.Tag = .CommentImgIndex ' store comment image index in Tag prop.
                ' set image for comment column(3) @ current row 
                If .CommentImgIndex > -1 Then
                    ListView_SetSubItemImageIndex(ListView1.Handle, ListView1.Items.Count - 1, ListView1.Columns(3).Index, .CommentImgIndex)
                End If
            End With
        Next
        ' all done checking for new rcvd reps.
        Dim addedPoints, newRepPoints As Integer
        If repRcvdThreads.Count > 0 Then ' we got new rep.
            ' sort date column desending
            sortDateColumnDesend()
            ' rep points
            Dim sTmp As String = GetTextBetween(sourceHTML, "Latest Reputation Received (", " point").Trim
            lblPoints.Text = sTmp & " Point(s)"
            lblPoints.Refresh()
            ' get how many points were added since last update.
            Integer.TryParse(sTmp, newRepPoints)
            addedPoints = newRepPoints - currentRepPoints
            ' save my reps to file
            SaveReps()
        End If
        ' show result
        lblNumReps.Text = "Reps:" & ListView1.Items.Count.ToString
        lblNumReps.Refresh()
        ' Add rep received info to string
        results = "New Reps Rcvd: " & repRcvdThreads.Count.ToString & Environment.NewLine & "Points Added: " & addedPoints.ToString & Environment.NewLine & Environment.NewLine
    End Sub

#End Region

    ' Misc Subs, Functions
#Region "Misc Subs, Functions"
    ' Function - Get text between strings
    Private Function GetTextBetween(MainText As String, StartText As String, EndText As String, Optional occurance As Integer = 1) As String
        If occurance < 1 Then occurance = 1
        Try
            Dim p1 As String = MainText.Split({StartText}, StringSplitOptions.None)(occurance)
            Return p1.Split({EndText}, StringSplitOptions.None)(0)
        Catch
            Return ""
        End Try
    End Function

#End Region

    ' Status history
#Region "Status history"
    ' combo - status history - drop down
    Private Sub CboStatus_DropDown(sender As Object, e As System.EventArgs) Handles CboStatus.DropDown
        With CboStatus
            If .Items.Count > 0 Then
                ' make dropdown list as wide as needed to see the widest message.
                Dim itemWidth, widestItem As Integer
                Dim itemText As String = ""
                For Each item In .Items
                    itemText = item.ToString.Replace(Environment.NewLine, "  ")
                    itemWidth = TextRenderer.MeasureText(itemText, .Font).Width
                    If itemWidth > widestItem Then widestItem = itemWidth
                Next
                If widestItem > .Width Then ' fit to widest message
                    .DropDownWidth = widestItem
                Else 'set drop list width to same width as control
                    .DropDownWidth = .Width
                End If
                ' scroll to / select last entry 
                .SelectedIndex = .Items.Count - 1
            End If
        End With
    End Sub

    ' combo - status history - index change
    Private Sub CboStatus_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles CboStatus.SelectedIndexChanged
        ' set index to last item in list since this is for status history only!
        If CboStatus.Items.Count > 0 Then
            CboStatus.SelectedIndex = CboStatus.Items.Count - 1
        End If
    End Sub

    ' Sub - update status - Add and display a status message
    Private Sub UpdateStatus(text As String)
        CboStatus.Items.Add(text)
        CboStatus.Text = text
        CboStatus.Refresh()
    End Sub

#End Region

End Class
